 #include <X11/Xlib.h>
 #include <stdio.h>
 #include <stdlib.h>
 #define LEFT_BORDER 400
 #define DOWN_BORDER 300
 #define x0 200
 #define y0 100
 #define LENGTH 100
 #define UP 111
 #define DOWN 116
 #define LEFT 113
 #define RIGHT 114

inline char selfeat (unsigned int *x, unsigned int  *y, unsigned int xn, unsigned int  yn)
{
    unsigned int count=1;
    while (count != LENGTH) 
    {
        if ((x[count] == xn) && (y[count] == yn)) return (0);
        count++;
    }
    return (1);
    
}

inline char prepare (Display *d, Window w, unsigned int s,
         unsigned int *x, unsigned int *y, unsigned int mv)
{
    XSetForeground(d, DefaultGC(d, s), 0x000000);
    XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]);
    XSetForeground(d, DefaultGC(d, s), 0xFFFFFF);
    XDrawPoint(d, w, DefaultGC(d, s), x[mv], y[mv]); //закрашиваем белым то место, где был зад
    y[mv]=*y;
    x[mv]=*x;
return (1);
}

//char postoper 


inline char read_KeyPress (XEvent *eventp, unsigned int *x,
                   unsigned int  *y, unsigned int *mv,
                   char *plusminus, Display *d, Window w,
                   unsigned int s)
{
    XKeyEvent *e = (XKeyEvent *) eventp;
    switch (e->keycode) {
        case UP: //up
              if (((*y) != 0) && (selfeat (x, y, x[0], (y[0]-1))))
              {
                  prepare (d, w, s, x, y, *mv);
                  (*y)--;
                  XSetForeground(d, DefaultGC(d, s), 0xFF0000);
                  XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]);
                  switch (*mv)
                  {
                      case LENGTH: {*mv=1; *plusminus=1;}
                      case 1: {*mv=LENGTH; *plusminus=-1;}
                      default: *mv=*mv+*plusminus;
                  }
              }
              break;
        case DOWN: //down
              if (((*y) != DOWN_BORDER-1) && (selfeat (x, y, x[0], (y[0]+1))))
              {   
                  prepare (d, w, s, x, y, *mv);
                  (*y)++;
                  XSetForeground(d, DefaultGC(d, s), 0xFF0000);
                  XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]);
                  switch (*mv)
                  {
                      case LENGTH: {*mv=1; *plusminus=1;}
                      case 1: {*mv=LENGTH; *plusminus=-1;}
                      default: *mv=*mv+*plusminus;
                  }
              }
              break;
        case LEFT:
              if (((*x) != 0) && (selfeat (x, y, (x[0]-1), y[0])))
              {
                  prepare (d, w, s, x, y, *mv);
                  (*x)--;
                  XSetForeground(d, DefaultGC(d, s), 0xFF0000);
                  XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]);
                  switch (*mv)
                  {
                      case LENGTH: {*mv=1; *plusminus=1;}
                      case 1: {*mv=LENGTH; *plusminus=-1;}
                      default: *mv=*mv+*plusminus;
                  }
              }
              break;
        case RIGHT:
              if (((*x) != LEFT_BORDER-1) && (selfeat (x, y, (x[0]+1), y[0])))
              {
                  prepare (d, w, s, x, y, *mv);
                  (*x)++;
                  XSetForeground(d, DefaultGC(d, s), 0xFF0000);
                  XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]);
                  switch (*mv)
                  {
                      case LENGTH: {*mv=1; *plusminus=1;}
                      case 1: {*mv=LENGTH; *plusminus=-1;}
                      default: *mv = *mv+*plusminus;
                  }
              }
              break;
    }
    return 0;
}


 
int main(void) 
{
    unsigned int x[LENGTH], y[LENGTH];
    Display *d;
    Window w;
    unsigned int s;
    unsigned int mv; //переброс пикселей из зада вперед
    unsigned int count;
    char plusminus;
    XEvent e;
    
                        /* open connection with the server */
    d = XOpenDisplay(NULL);
    if (d == NULL) {
    fprintf(stderr, "Cannot open display\n");
    exit(1);
    }
 
    s = DefaultScreen(d);
 
                        /* create window */
    w = XCreateSimpleWindow(d, RootWindow(d, s), 10, 10, LEFT_BORDER, DOWN_BORDER, 1,
                           BlackPixel(d, s), WhitePixel(d, s));
 
                        /* select kind of events we are interested in */
    XSelectInput(d, w, ExposureMask | KeyPressMask);
 
                        /* map (show) the window */
    XMapWindow(d, w);
    mv=LENGTH;
    count = 2;
    do
    {
        x[count]=1+x0-count;
        y[count]=y0;
        count++;
    }
    while (count != (LENGTH));
    mv=1;
    x[0]=x0;
    y[0]=y0;
    x[1]=x0-LENGTH+1;
    y[1]=y0;
                           /* event loop */
    while (1)
    {
        XNextEvent(d, &e);
        if (e.type == Expose)
        {
            XSetForeground(d, DefaultGC(d, s), 0xFF0000);
            XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]);
            count=1;
            XSetForeground(d, DefaultGC(d, s), 0x000000);
            //рисуем змею
            do
            {
                XDrawPoint(d, w, DefaultGC(d, s), x[count], y[count]);
                count++;
            }
            while (count != (LENGTH));
        }    
        if (e.type == KeyPress)
        {
            read_KeyPress (&e, x, y, &mv, &plusminus, d, w, s);
        }    
    }
    return 0;
}